﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirBomber
{
    internal class DrawningObject : IDrawningObject
    {
        private DrawningAirplane _airplane = null;

        public DrawningObject(DrawningAirplane airplane)
        {
            _airplane = airplane;
        }

        public float Step => _airplane?.Airplane?.Step ?? 0;

        public RectangleF GetCurrentPosition()
        {
            return _airplane.GetCurrentPosition();
        }

        public void MoveObject(Direction direction)
        {
            _airplane?.MoveTransport(direction);
        }

        public void SetObject(int x, int y, int width, int height)
        {
            _airplane.SetPosition(x, y, width, height);
        }

        void IDrawningObject.DrawningObject(Graphics g)
        {
            _airplane.DrawTransport(g);
        }
    }
}
